//+------------------------------------------------------------------+
//|                                                     AutoStop.mq4 |
//|                                                      nicholishen |
//|                            http://www.reddit.com/u/nicholishenFX |
//+------------------------------------------------------------------+
#property copyright "nicholishen"
#property link      "http://www.reddit.com/u/nicholishenFX"
#property version   "1.00"
#property strict
#include <Arrays\ArrayInt.mqh>

class AutoStop
{
protected:
   CArrayInt      m_list;
   int            m_orders_total;
   int            m_stop_points;
public:
                  AutoStop(int stop_points):m_orders_total(-1),
                                            m_stop_points(stop_points){}
   void           Refresh();
   void           OnInit();
};
//+------------------------------------------------------------------+
//| EA functions
//+------------------------------------------------------------------+
//--- input parameters
input int Stop_Points=100;//Stoploss in points not Pips
AutoStop auto_stop(Stop_Points);
//+------------------------------------------------------------------+
int OnInit()
{
   auto_stop.OnInit();
   EventSetMillisecondTimer(100);
   return(INIT_SUCCEEDED);
}
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
{
   EventKillTimer();
}
//+------------------------------------------------------------------+
void OnTick()
{
   auto_stop.Refresh();
}
//+------------------------------------------------------------------+
void OnTimer()
{
   auto_stop.Refresh();
}
//+------------------------------------------------------------------+
//+ class methods
//+------------------------------------------------------------------+
void AutoStop::Refresh()
{
   int total = OrdersTotal();
   if(m_orders_total == total)
      return;
   m_orders_total = total;
   for(int i=0;i<total;i++)
   {
      if(OrderSelect(i,SELECT_BY_POS) && OrderSymbol()==Symbol())
      {
         if(m_list.SearchLinear(OrderTicket())<0 && OrderStopLoss()==0.0)
         {
            double stop = OrderType() == OP_BUY?OrderOpenPrice()-m_stop_points*_Point:OrderOpenPrice()+m_stop_points*_Point; 
            if(!OrderModify(OrderTicket(),OrderOpenPrice(),stop,OrderTakeProfit(),OrderExpiration()))
               Print(__FUNCTION__," OrderModify error: ",GetLastError());
            else
               m_list.Add(OrderTicket());
         }
      }
   }
}
//+------------------------------------------------------------------+
void  AutoStop::OnInit()
{
   m_list.Clear();
   for(int i=0;i<OrdersTotal();i++)
      if(OrderSelect(i,SELECT_BY_POS) && OrderSymbol()==Symbol())
         m_list.Add(OrderTicket());
}